/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 *
 *  http://aws.amazon.com/apache2.0
 *
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package software.amazon.awssdk.core.auth.policy.internal;

public final class JsonDocumentField {

    public static final String VERSION = "Version";
    public static final String POLICY_ID = "Id";
    public static final String STATEMENT = "Statement";
    public static final String STATEMENT_EFFECT = "Effect";
    public static final String EFFECT_VALUE_ALLOW = "Allow";
    public static final String STATEMENT_ID = "Sid";
    public static final String PRINCIPAL = "Principal";
    public static final String ACTION = "Action";
    public static final String RESOURCE = "Resource";
    public static final String CONDITION = "Condition";

    private JsonDocumentField() {
    }
}
